#include "Bench.h"
#include "Timer.h"

Bench::Bench()
{
}

double Bench::measureFlops()
{
	Timer watch;
	double flops;
	double totaltime;
	long fp_ops;

	watch.startTimer();
	fp_ops = run();
	totaltime = watch.stopTimer();

        flops = (double) fp_ops / (double) totaltime / (double) 1000000;

	return flops;
}

long Bench::run()
{
	int i,j;

	int r, r2;
	double s, s2;
	int SIZE = 300000;	// how many repetetion of the calc to do

	/* fill our arrays with random values */

	for (i=0; i<SIZE; i++)
	{
		r = r + i / 3 * (i - 100);	/* 4 ops */
		s = s + (double) i / 3.343536 * (s - 12.12121212);   /* 4 ops */

		r2 = r*r*r*r*r / 4 / 5 / 6 / 7;                /* 8 ops */
		s2 = s*s*s*s*s / 4.0 / 5.0 / 1235.23 / 0.23123;   /* 8 ops */

		r2 = r2 + 12 + 34 + -1231 + 39823 - 2322 - 0 + 999 - 1; /* 8 ops */
		s2 = s2 + 12.0 + 34.45 - 438.345 + 23.0 - 633.33433434 +
					2.0 - 1.0 + 32.29829382982398;  /* 8 ops */
	}
	/* 40 * SIZE ops were done */

	return 40*SIZE;
}	



