//***********************************************************
//
// A virtual Shape object. Overloads "Shape". A box can only
// have its sides vertical and horizontal. To make the box
// have any general orientation, an angle must be stored, then
// use the rotated coordinate system.
//
// Written by: Brian Schlatter
// Last updated: 6/12/1999
//
//********************************************************** 


#ifndef BOX_HPP
#define BOX_HPP

#include <math.h>
#include <stdlib.h>
#include <assert.h>
#include "Point.h"
#include "Shape.h"

class Box : public Shape {
	public:
		Box();
		Box(Point b, double w, double h);
		Box (const Box & B);
		Box & operator = (const Box & L);
		~Box() {}
		
		//Miscellaneous methods.

		double area() const;
		double length() const;
		int isInside(double , double );
		double calcRatioOfDistances(Point , Point );
		void print();		

		friend ostream & operator << (ostream & , const Box & );
		friend ofstream & operator << (ofstream & , const Box & );

};

#endif



	
