//***********************************************************
//
// A base class for Smoothparticle. 
//
// Written by: Brian Schlatter
// Last updated: 6/12/1999
//
//********************************************************** 
#ifndef PARTICLE_HPP
#define PARTICLE_HPP

#include "Point.h"


class Particle {
	public:
		//Constructor and Destructor.
		Particle();
		Particle(Point p, Point v, double m);
		Particle(const Particle & P);
		~Particle() {}


		//Accessor Methods.
		void setPosition(Point p)              { pos = p;           }
		void setPositionX(double x)            { pos.setX(x);       }
		void setPositionXY(double x, double y) { pos.setXY(x, y);   }
		void setPositionY(double y)            { pos.setY(y);       }
		void setVelocity(Point v)              { vel = v;           }
		void setVelocityX(double x)            { vel.setX(x);       }
		void setVelocityY(double y)            { vel.setY(y);       }
		void setVelocityXY(double x, double y) { vel.setXY(x, y);   } 
		void setMass(double m)                 { mass = m;          }
		void deleteParticle()		       { deleted = 1; }
		void undeleteParticle()		       { deleted = 0; }
		Point getPosition()   const            { return pos;        }
		double getPositionX() const            { return pos.getX(); }
		double getPositionY() const            { return pos.getY(); }
		Point getVelocity()   const            { return vel;        }
		double getVelocityX() const            { return vel.getX(); }
		double getVelocityY() const            { return vel.getY(); }
		double getMass()      const            { return mass;       }
		int isEmpty()		  const    	       { return deleted; }
	
		Particle & operator = (const Particle & P);	
		friend ostream & operator << (ostream & str, const Particle & p);
		friend ofstream & operator << (ofstream & fStr, const Particle & p);
		

	protected:
		Point pos;
		Point vel;
		double mass;
		int deleted;
};





#endif
