
// Simple class to hold particle data to be put into our AttributeGrid

public class Particle implements globals
{    
    public float pos_x;
    public float pos_y;
    public float density;
    public float pressure;
    public float vel_x;
    public float vel_y;
    public float speed;
    public int ID;
    public int shapeID;
            
    public Particle()
    {
        pos_x = 0.0f;
        pos_y = 0.0f;
        density = 0.0f;
        pressure = 0.0f;
        vel_x = 0.0f;
        vel_y = 0.0f;
        speed = 0.0f;
        ID = 0;
        shapeID = 0;       
    }
    
    public String toString()
    {
        return "(" + pos_x + ", " + pos_y + ")  vel ("
                + vel_x + ", " + vel_y + ")  speed = " + speed + 
                "density = " + density + "  pressure = " + pressure + "  ID = "
                + ID + "  shapeID = " + shapeID;
    }
    
    // set our attributes based on a passed packet
    public Particle(float [] buffer)
    {
        pos_x    = buffer[0];
        pos_y    = buffer[1];        
        vel_x    = buffer[2];
        vel_y    = buffer[3];
        speed    = buffer[4];
        density  = buffer[5];
        pressure = buffer[6];
        ID       = (int) buffer[7];
        shapeID  = (int) buffer[8];   
        
    }

    public float [] get_packet()
    {
        float [] buffer = new float[SMOOTH_SIZE_CLIENT];
        
        buffer[0] = pos_x;
        buffer[1] = pos_y;        
        buffer[2] = vel_x;
        buffer[3] = vel_y;
        buffer[4] = speed;
        buffer[5] = density;
        buffer[6] = pressure;
        buffer[7] = (float) ID;
        buffer[8] = (float) shapeID;   
        
        return buffer;
    }
}