// comapre debug files of our sph simulation to check for
// differences

import java.lang.*;
import java.io.*;
import java.util.*;
import java.awt.*;

public class compare
{
    public static void main (String args[]) throws IOException
    {
        int VERBOSE = 0;
        String temp = new String("blah");
        
        DataInputStream input1, input2;
	Vector pts1 = new Vector();
	Vector pts2 = new Vector();
        
        input1 = new DataInputStream(new FileInputStream(args[0]));
        input2 = new DataInputStream(new FileInputStream(args[1]));

	if (args[2] != null)
		VERBOSE = (new Integer(args[2])).intValue();

	double x, y, velX, velY;
	double pressure, density, changeDensityX, changeDesnityY;
	double changeVelocityX, changeVelocityY;

	int count1, count2, id;

	count1 = 0;
	count2 = 0;

	try {

		temp = input1.readLine();
		
		while ((temp != null) && (temp.length()>1))
		{
			pts1.addElement(new particle(temp));
			count1++;

			temp = input1.readLine();
		}

		temp = input2.readLine();

		while ((temp != null) && (temp.length()>1))
		{
			pts2.addElement(new particle(temp));
			count2++;

			temp = input2.readLine();
		}

	}		
	catch (Exception e)
	{
		e.printStackTrace();
	}

	if (VERBOSE != -1)
	{
		System.out.println("" + args[0] + " has " + count1 + " points");
		System.out.println("" + args[1] + " has " + count2 + " points");
	}

	// now sort the vectors by x coordinate (y in a tie)

	Vector sort1 = new Vector();
	Vector sort2 = new Vector();
	
	int i, j;
	int min;
	int min_j;
	
	for (i = 0; i < count1; i++)
	{
		min = ((particle) pts1.elementAt(0)).id;
		min_j = 0;

		for (j = 0; j < pts1.size(); j++)
		{
			// find the minimum element left in the vector

			id = ((particle) pts1.elementAt(j)).id;

			if (id < min)
			{	
				min = id;
				min_j = j;
			}
		}
		// add the min element to our sorted vector
		sort1.addElement(pts1.elementAt(min_j));
		pts1.removeElementAt(min_j);
	}	

	for (i = 0; i < count2; i++)
	{
		min = ((particle) pts2.elementAt(0)).id;
		min_j = 0;

		for (j = 0; j < pts2.size(); j++)
		{
			// find the minimum element left in the vector

			id = ((particle) pts2.elementAt(j)).id;

			if (id < min)
			{	
				min = id;
				min_j = j;
			}
		}

		// add the min element to our sorted vector
		sort2.addElement(pts2.elementAt(min_j));
		pts2.removeElementAt(min_j);
	}	

//	for (i=0; i < Math.min(sort1.size(), sort2.size()); i++)

	if (VERBOSE > 2)
	{
		for (i=0; i < sort1.size(); i++)
			System.out.println("" + sort1.elementAt(i));
		System.out.println("-----------------------------------");
	
		for (i=0; i < sort2.size(); i++)
			System.out.println("" + sort2.elementAt(i));
		System.out.println("-----------------------------------");
	}

	int diff = 0;
	double posabs = 0.0;
	double abs = 0.0;
	double change;

	int id1, id2;
	int missing = 0;

	i = 0;
	j = 0;

	while ((i < sort1.size()) && (j < sort2.size()))
	{
		id1 = ((particle) sort1.elementAt(i)).id;
		id2 = ((particle) sort2.elementAt(j)).id;

		if (id1 != id2)
		{
			// they didn't match, skip over this one

			missing++;

			if (id1 < id2)
			{
				if (VERBOSE > 0)
					System.out.println("ID " + id1 + " missing from second file");
				i++;
			}
			else
			{
				if (VERBOSE > 0)
					System.out.println("ID " + id2 + " missing from first file");
				j++;
			}
		}
		else
		{

			change = ( ((particle) sort1.elementAt(i)).
				calcDiff((particle) sort2.elementAt(j)) );
			posabs += ( ((particle) sort1.elementAt(i)).
				calcPosDiff((particle) sort2.elementAt(j)) );
			if (change!=0.0)
			{
				if (VERBOSE > 1)
				{
					System.out.println("" + (particle) sort1.elementAt(i));
					System.out.println("" + (particle) sort2.elementAt(j));
				}	

				abs += change;
		
				diff++;
			}
			i++;
			j++;
		}
	}

	if (VERBOSE==-1)
	{
		System.out.println("" + posabs / Math.min(sort1.size(), sort2.size()) + "   " + missing);
	}
	else
	{
		System.out.println("" + diff + " points were different");
		System.out.println("" + missing + " points were missing");
		System.out.println("Absolute difference = " + abs);
		System.out.println("Absolute pos difference = " + posabs);
		System.out.println("Average pos difference = " + posabs / Math.min(sort1.size(), sort2.size()));

		if (count1!=count2)
			System.out.println("Panic!  Different number of points in the files");
  	}

        input1.close();
        input2.close();

    }


}
