#ifndef _MSGTAGS
#define _MSGTAGS

#define CLIENT_MODE 	1		// set to 0 if you intend to use the client to control the server
					// set to 1 to use parameters and world specified in Master.cpp

#define UPDATE_EVERY    1		// how often to do slave-slave updates
					// you must replace SlaveGrid with SlaveGridLazy for this to work
					// leave at 1 unless you know what you are doing

#define TRACK_NEIGHBORS 0		// whether we want to track the number of neighbors each particle has (used for debugging)

// These control what output files the server will write to disk
// If you are using the client, you probably want these off
#define REV_OUTPUT_CLIENT 1             // some architectures will need to reverse the bytes when writing the client format data file
#define OUTPUT_CLIENT   1	        // output a client format frame, these can be read later by the client application
#define OUTPUT_IMAGE	0		// output sgi (rgb) image frame
#define OUTPUT_DEBUG    0		// output a debugging frame, can be read by compare.java and trace.java
#define OUTPUT_NEIGHBOR 0		// output a particle list with how many neighbors each one has

// These control output using the ImageSGI class, created SGI (rgb)
// format raw image files
#define CHECKERS	1		// turn on and off the background checkerboard
#define IMAGE_WIDTH 640			// width of the .rgb frame
#define IMAGE_HEIGHT 480		// height of the .rgb frame
#define SGI_MIN_X -0.03			// lower left world coordinate of the frame
#define SGI_MIN_Y -0.03
#define SGI_MAX_X 0.18			// upper right world coordinate
#define SGI_MAX_Y 0.18

// These control how big the various communication packets will be
#define PARAM_SIZE 21		// how big our param packet is, sent from master to slaves
#define PARAM_SIZE_CLIENT 15	// how big our param packet is from the client
#define SMOOTH_SIZE 18		// how big our smooth particle packet is
#define SMOOTH_SIZE_CLIENT 9	// used when we send particles to client, the client doesn't need all the smooth particle attributes 

// MPI message tags used by the master and slaves
#define TAG       	0	// MPI message tag
#define NUMTAG    	1	// number of particles message tag
#define PTSTAG    	2	// particle data tag
#define NUM_UPDATE    	3	// num slave is updating to master
#define PTS_UPDATE    	4	// updating master about particles
#define TIME_UPDATE     5	// tell master how long we do calcs
#define COMMAND         6
#define UPDATE_OFFSET   4242	// starting point for our master-slave message tags, this is an arbitary number

// commands used on MPI and socket links
#define BYE       0		
#define STATS     1
#define SHUTDOWN  2
#define PARAMS    3
#define WORLD     4
#define NETWORK   5
#define RUNSIM    6

#endif
