/* Takes the C++ client on a little test spin 

   Keith Vertanen 4/99 */

#include "client.h"

#define SIZE 10		  /* how many items per packet */
#define NUM_PACKS 3	  /* number of times we'll do it */

void main(int argc, char *argv[])
{
	double C[SIZE];
	char D[SIZE];

	/* if no command line arguments passed, we'll default to 
		these two port number */

	int port = 5010;
	int dataport = 5011;
	int rev = 1;

	if (argc<2)
	{
		printf("Not enough command line arguments!\n\n");
		printf("    client_test system-name (port) (dataport) (reverse byte order)\n\n");
		exit(-1);
	}

	/* pass one argument or all 4 */

	if (argc>4)
	{
		port = (int) atol(argv[2]);		
		dataport = (int) atol(argv[3]);
		rev = (int) atol(argv[4]);
	}

        Client mylink(port, dataport, argv[1], rev);

	/* put some dummy data in our arrays */

	for (int i=0; i<SIZE; i++)
	{
		C[i] = (double) i*i+0.5;
		D[i] = i;
	}

	for (int i=0; i<NUM_PACKS; i++)
	{
		mylink.recv_bytes(D, SIZE);
		mylink.send_doubles(C, SIZE);
	}

	mylink.closesocket();
}

