/* Takes the C++ server on a little test spin 

   Keith Vertanen 4/99 */

#include "server.h"

#define SIZE 10		  /* how many items per packet */
#define NUM_PACKS 3	  /* number of times we'll do it */

void main(int argc, char *argv[])
{
	double C[SIZE];
	char D[SIZE];

	/* if no command line arguments passed, we'll default to 
		these two port number */

	int port = 5010;
	int dataport = 5011;
	
	if (argc>2)
	{
		port = (int) atol(argv[1]);
		dataport = (int) atol(argv[2]);
	}

	Server mylink(port, dataport);

	/* put some dummy data in our arrays */

	for (int i=0; i<SIZE; i++)
	{
		C[i] = (double) i*i+0.5;
		D[i] = i;
	}
	mylink.connect();

	for (int i=0; i<NUM_PACKS; i++)
	{
		mylink.send_bytes(D, SIZE);
		mylink.recv_doubles(C, SIZE);
	}

	mylink.closesocket();
}

