// trace particle attribute through time
// reads .debug files

import java.lang.*;
import java.io.*;
import java.util.*;
import java.awt.*;

/*

command line:  particle_ID directory start_index end_index attributes

	  attributes:  	0 - position x
			1 - position y
			2 - velocity x
			3 - velocity y
			4 - pressure
			5 - density
			6 - change density
			7 - change velocity x
			8 - change velocity y
			9 - the file number

directory must have trailing /

start_index and end_index are the numbers in out.xxxx.debug

*/

public class trace
{
    public static void main (String args[]) throws IOException
    {
	int ID, start, end;
	particle target = new particle();

        String temp = new String("blah");
        
        DataInputStream input1, input2;
	Vector pts1 = new Vector();
        
	ID    = (new Integer(args[0])).intValue();
	start = (new Integer(args[2])).intValue();
	end   = (new Integer(args[3])).intValue();

	int [] attribute = new int[args.length - 4];

	for (int k=0; k<args.length - 4; k++)
		attribute[k]   = (new Integer(args[k+4])).intValue();

	String filename = new String("");

	for (int i = start; i<=end; i++)
	{
		if (i < 10)
			filename = new String("" + args[1] + "out.000" + i + ".debug");
		else if (i < 100)
			filename = new String("" + args[1] + "out.00" + i + ".debug");
		else if (i < 1000)
			filename = new String("" + args[1] + "out.0" + i + ".debug");
		else 
			filename = new String("" + args[1] + "out." + i + ".debug");

		input1 = new DataInputStream(new FileInputStream(filename));

		boolean found = false;

		try {
	
			temp = input1.readLine();
		
			while ((temp != null) && (temp.length()>1))
			{
				target = new particle(temp);

				if (target.id == ID)
				{
					found = true;
					break;
				}

				temp = input1.readLine();
			}

		}		
		catch (Exception e)
		{
			e.printStackTrace();
		}

        	input1.close();

		if (found)
		{
			for (int k = 0; k < args.length - 4; k++)
			{
				switch (attribute[k])
				{
					case 0: System.out.print("\t" + target.posX); break;
					case 1: System.out.print("\t" + target.posY); break;
					case 2: System.out.print("\t" + target.velX); break;
					case 3: System.out.print("\t" + target.velY); break;
					case 4: System.out.print("\t" + target.pressure); break;
					case 5: System.out.print("\t" + target.density); break;
					case 6: System.out.print("\t" + target.changeDensity); break;
					case 7: System.out.print("\t" + target.changeVelocityX); break;
					case 8: System.out.print("\t" + target.changeVelocityY); break;
					case 9: System.out.print("\t" + i); break;
				}
			}
			System.out.println("");
		}
		else
		{
			System.out.println("Particle " + ID + " not found in file " + i);
		}
	}
    }
	
}
